; tasm /m scantree.asm
; tlink /t /x scantree.obj

.MODEL Tiny
.286
.CODE
ORG	100h

LOCALS

PathLen		=	100            ; ᨬ   䠩/⠫
                                       ; (㬥  祭 ⥫쭮)
Start:

		push	offset MyFunc
		call	ScanTree

		int	20h

MyFunc		proc
		lea	di,ScanPath    ; DI =  ப ScanPath
		push	di
		mov	cx,PathLen
		xor	al,al
		repne	scasb          ; 饬  ப
		dec	di
		mov	word ptr [di],0A0Dh ; 뢠 㤠 CR,LF...
		mov	byte ptr [di+2],'$' ; ... ᨬ  ( - 9)

		mov	ah,9
		pop	dx
		int	21h            ; 뢮 ப  ࠭

		mov	byte ptr [di],0; ⠭ ப ScanPath
		                       ; (..   )
		ret
MyFunc		endp

; ᪨ ਡ⮢ 䠩/⠫
faReadOnly	=	1
faHidden	=	2
faSystem	=	4
faVolume	=	8
faDirectory	=	10h
faArchive	=	20h
faAnyFile	=       faReadOnly+faHidden+faSystem+faArchive
faAnyDir	=	faAnyFile+faDirectory
faAnithing	=	faAnyDir+faVolume

; ᠭ  DTA
DTAFileInfo	struc
dtaReserved	db	21 dup (?)
dtaAttr		db	?
dtaTime		dw	?
dtaDate		dw	?
dtaSize		dd	?
dtaName		db	13 dup (?)
ends

; 楤 室  ⠫  ⠫.
; 楤  ࠡ   ணࠬ ଠ DOS EXE !!!
;  室:
; - ६ StartPath (  ScanPath) ᮤন  ⮢ ⠫.
;    ⠫  稢  襬 ('\') !
; -  ⥪ ᬥ饭 (word) near-㭪樨,  㤥 뢠  
;    ⠫.  ⮬   ᯮ짮 ASCIIZ-ப ScanPath,
;    ᮤন    ⠫  襬  ,  
;      ப!  室 㭪  ᪮஢
;   ப  - ,      ,  㦭 :)
;   㭪 ⠪   ᯮ짮 ⠭ DTA,  室
;   㦭 ᮧ ᢮  DTA.  ०  ⠭ 
;   室  㦭,   ॣ DS, ES, ᫨  뫨 .
;  室:
; - DTA  ॣ DS,BP ࠭.
; - ப StartPath/ScanPath ᮤন   ᫥  ⠫.
; - ES:DI 㪠뢠   ப StartPath/ScanPath,  뫠  맮
;   㭪樨 (..  ᤥ xor al,al / stosb  ᭮ 맢 ScanTree).
ScanTree	proc	pascal
arg		Func:word
local		OldDTA:dword, NewDTA:DTAFileInfo
; ES ᥣ ࠢ ࢮ砫쭮 DS !!!

		push	ds             ; ࠭塞 DS
		mov	ah,2Fh
		int	21h            ; 砥  DTA
		mov	word ptr OldDTA[0],bx ; ࠭塞 ...
		mov	word ptr OldDTA[2],es ; ... ६ OldDTA
		pop	es             ; ⠭ DS  ॣ ES (ES=DS)

		lea	di,ScanPath
		mov	cx,PathLen
		xor	al,al
		cld                    ; אַ 冷 ᪠ scasb
		repne	scasb          ; 饬   ⠫ 㫥  ( ப)
		dec	di
		push	di             ; ࠭塞 㪠⥫  

		push	ds es          ; ࠭塞 DS  ES
		call	Func           ; 뢠 㭪  ⮢ ⠫

		mov	ah,1Ah
		push	ss
		pop	ds             ; DS = SS (ᥣ NewDTA)
		lea	dx,NewDTA
		int	21h            ; ⠭ ᢮ DTA
		pop	es ds          ; ⠭ DS  ES (ES=DS)

		mov	ah,4Eh         ; ⮢  砫 ᪠
		mov	cx,faAnyDir    ; ਡ (, ஬ Volume label)
		lea	dx,ScanPath

		lea	si,ScanMask    ; SI =   ᪠
		pop	di             ; ⠭ DI (㪠⥫   ப)...
		push	di             ; ...   ࠭塞 
		cld                    ; אַ 冷 ࠡ lodsb/stosb
@@CopyMask:	lodsb                  ; ⠥  AL ᨬ  ப [SI]
		stosb                  ;  뢠    ScanPath
		or	al,al          ;  ப [SI] (AL=0) ?
		jnz	@@CopyMask     ; , 㥬 ᫥騩 ᨬ
@@FindNext:
		int	21h            ; 稭/த 
		jc	@@NotFound     ; 室, ᫨ 祣   (CF=1)

		push	ss
		pop	ds             ; DS = SS (ᥣ NewDTA)

		test	NewDTA.dtaAttr,faDirectory ; ஢塞 - ⠫   
		jz	@@PrepareNext  ; ᫨ , ⮢ த 
		lea	si,NewDTA.dtaName ;    䠩/⠫
		lodsb                  ; ⠥  ᨬ
		cmp	al,'.'         ;  ⠫ '.'  '..'? ( ⠪  㦭)
		je	@@PrepareNext  ; ᫨  , ⮢ த 

		pop	di             ; ⠭ DI (㪠⥫   ப)...
		push	di             ; ...   ࠭塞 
@@CopyPath:	
		stosb                  ; 뢠 ᨬ ப [SI]   ScanPath
                lodsb                  ; ⠥  AL ᨬ  ப [SI]
		or	al,al          ;  ப [SI] (AL=0) ?
		jnz	@@CopyPath     ; , 㥬 ᫥騩 ᨬ
		mov	ax,'\'         ; AH = 0, AL = '\'
		stosw                  ; 뢠      ப

		push	es
		pop	ds             ; DS = ES
		push	Func
		call	ScanTree       ; 뢠 ᥡ ४ᨢ
		push	ss
		pop	ds             ; DS = SS (ᥣ NewDTA)
@@PrepareNext:
		mov	ah,4Fh         ; ⮢  㭪樨 4Fh
		lea	dx,NewDTA
		jmp	@@FindNext     ; த 
@@NotFound:
		pop	di             ; ࠥ  ⥪ DI

		mov	ah,1Ah
		lds	dx,OldDTA
		int	21h            ; ⠭ DTA

		push	es
		pop	ds             ; ⠭ ࢮ砫 DS
		ret                    ; 室  楤
ScanTree	endp

.DATA

ScanMask	db	'*.*',0        ; ᪠ ⠫  ᪠
                                       
StartPath	db	'C:\',0        ; ⮢ ⠫
ORG StartPath                          ; 頥 StartPath  ScanPath
ScanPath	db	PathLen dup (?) ; ASCIIZ-  ⠫

END		Start
