; ml /c /coff wintsr.asm
; link /subsystem:windows /section:.text,rwe wintsr.obj

.586P
.MODEL Flat,StdCall
OPTION CASEMAP:NONE

INCLUDE		D:\MASM32\INCLUDE\WINDOWS.INC
INCLUDE		D:\MASM32\INCLUDE\KERNEL32.INC
INCLUDE		D:\MASM32\INCLUDE\USER32.INC
INCLUDELIB	D:\MASM32\LIB\KERNEL32.LIB
INCLUDELIB	D:\MASM32\LIB\USER32.LIB

MEM_SHARED	equ	8000000h       ; ,   

.DATA

Text		db	'     Windows NT/2000/XP :(',0
Caption		db	', ?',0

.CODE

;   
Intr		=	51h            ; IRQ  

Start:

;   (Windows 9X  NT)
		invoke	GetVersion     ;   
		or	eax,eax        ;   ?
		js	@@Continue     ; ,  Windows 9X, ! :)

		invoke	MessageBoxA, NULL, OFFSET Text, OFFSET Caption, MB_OK+MB_ICONERROR
		invoke	ExitProcess, NULL ; Goodbye!
@@Continue:
;  ,    (1 )
		invoke	VirtualAlloc, 0, 1000h, MEM_COMMIT+MEM_SHARED, PAGE_EXECUTE_READWRITE
		or	eax,eax
		jz	@@Exit         ; ,    

		cli                    ;   
		xchg	edx,eax        ;       EDX

;   IDT
		push	eax            ;    - (*)
		sidt	[esp-2]        ;       (  (*)) IDT
		pop	eax            ;   EAX  IDT  (*)

;    
		add	eax,Intr*8     ; EAX =    
		mov	ebx,[eax+4]    ;   EBX  ...
		mov	bx,[eax+0]     ;     
		mov	OldHandler,ebx ;     OldHandler

;     ,     
		mov	edi,edx
		mov	esi,offset Handler
		mov	ecx,lHandler
		rep	movsb          ;      EDX !

;       
		mov	[eax+0],dx     ;    
		shr	edx,16
		mov	[eax+6],dx     ;    

		sti                    ;   

;   
@@Exit:
		invoke	ExitProcess, NULL ; Goodbye!

;----------------------------------------------------------------------------;
;                 !            ;
;----------------------------------------------------------------------------;

Handler		proc

		pusha                  ;  ()  

;   
		in	al,61h         ;   AL    PB
		push	eax            ;  AL
		mov	edx,80h
@@SoundLoop:
;  
		and	al,not 11b
		out	61h,al
		mov	ecx,60h
		loop	$              ; 

;     
		or	al,10b
		out	61h,al
		mov	cl,60h
		loop	$              ; 

		dec	edx
		jnz	@@SoundLoop    ;  

		pop	eax            ;  AL
		out	61h,al         ;      PB

;       
		popa
		db	0EAh           ; jmp large (  )
OldHandler	dd	?              ;   
		dw	028h           ; 

Handler		endp

lHandler	=	$-Handler

END		Start
